$(document).ready(function() {
  $('.composeContainer input[type="text"]').on('focusin', function() {
    $(this).parent().toggleClass('focused');
  });
  $('.composeContainer input[type="text"]').on('focusout', function() {
    $(this).parent().toggleClass('focused');
  });
  $('.composeContainer textarea').on('focusin', function() {
    $(this).toggleClass('focused');
  });
  $('.composeContainer textarea').on('focusout', function() {
    $(this).toggleClass('focused');
  });
  if($('textarea').val().length) $('textarea').val("\r\n" + $('textarea').val());
  $('.composeContainer span.addAddress').on('click', function() {
    $('.overlay').show();
    $('#filterAddress').val('');
    $('.address li').show();
    $('div.address').show();
    $('div.address .mainPanelContent').attr('title', $(this).siblings('input').attr('name'));
  });
  $('.dialog .cancelButton').on('click', function() { $('.dialog .topPanelContainer img').trigger('click'); });
  $('.dialog .topPanelContainer img').on('click', function(e) {
    e.preventDefault();
    $('.dialog').hide();
    $('.overlay').hide();
  });
  $('.editorAddField span').on('click', function() {
    $(this).toggleClass('active');
    $('.editorField > span:contains("' + $(this).text() + '")').parent().toggle().children('input').val('');
  });
  $('.editorField input').each(function() {
    $(this).css('width', $(this).parent().width() - $(this).siblings('span').width() - 50);
  });
  $('.editorAddField span').each(function() {
    if(!$('.editorField > span:contains("' + $(this).text() + '")').siblings('input').val()) $(this).trigger('click');
  });
  $('.editorAttach .attach').on('click', function() {
    $('div.attachments').append('<input type="file" name="Attachment" />');
    var file = $('div.attachments input:last-child');
    file.on('change', function() {
      if(!file.val() || file.val() == "") {
        file.remove();
        return false;
      } else {
        $('.editorAttach .attach').before('<span class="attached">' + file.val().split('/').pop().split('\\').pop() + '</span>');
        $('.editorAttach .attached').on('click', function() {
          var that = this;
          $('div.attachments input').each(function() {
            if($(this).val().indexOf($(that).text()) >= 0 || !$(this).val() || $(this).val() == "") $(this).remove();
          });
          $(that).remove();
        });
      }
    });
    file.trigger('click');
  });
  $('div.address select').on('change', function() {
    $.get(
      "Compose.wssp",
      {
        addressBook: 1,
        selectedAddressBook: $(this).val(),
      },
      function(data) {
        var o = $.parseJSON(data);
        var list = o.list;
        list.length = list.length - 1;
        var result = '';
        var name;
        var mail;
        for(var i = 0; i < list.length; i++) {
          name = list[i].replace(/^(.*)\s&lt;.*&gt;$/, "$1");
          mail = list[i].replace(/^.*\s&lt;(.*)&gt;$/, "$1");
          result += '<li><table width="100%" border="0" cellpadding="0" cellspacing="0"><tr>' +
            '<td class="name" align="left">' + name + '</td>' +
            '<td class="mail" align="right">' + mail + '</td></tr></table></li>';
        }
        $('div.address .mainPanelContent').html(result);
        $('div.address .mainPanelContent li').on('click', function() {
          var field = $(this).parent().attr('title');
          var input = $('.composeContainer input[name="' + field + '"]');
          if(input.val() != '') input.val(input.val() + ', ');
          input.val(input.val() + $(this).find('.name').text() + ' <' + $(this).find('.mail').text() + '>');
          $(this).parent().removeAttr('title');
          $('div.address').hide();
          $('.overlay').hide();
        });
      }
    );
  });
  $('div.address select').trigger('change');
  jQuery.expr[":"].Contains = jQuery.expr.createPseudo(function(arg) {
    return function( elem ) {
      return jQuery(elem).text().toUpperCase().indexOf(arg.toUpperCase()) >= 0;
    };
  });
  $('#filterAddress').on('keyup', function() {
    if(this.value.replace(/\s/g).length) {
      $('.address li:Contains("' + this.value + '")').show();
      $('.address li:not(li:Contains("' + this.value + '"))').hide();
    }
    else $('.address li').show();
  });
  $('div.address').hide();
  $('a.ShowFreeBusy').on('click', function(e) {
    e.preventDefault();
    if($('input [name="ShowFreeBusy"]').length) $('input [name="ShowFreeBusy"]').val('1');
    else $('body>form').append('<input type="hidden" name="ShowFreeBusy" value="1" />');
    $('body>form')[0].submit();
  });
  $.datepicker.regional['ru'] = {
    monthNames: ['Январь','Февраль','Март','Апрель','Май','Июнь','Июль','Август','Сентябрь','Октябрь','Ноябрь','Декабрь'],
    monthNamesShort: ['Янв','Фев','Мар','Апр','Май','Июн','Июл','Авг','Сен','Окт','Ноя','Дек'],
    dayNames: ['воскресенье','понедельник','вторник','среда','четверг','пятница','суббота'],
    dayNamesShort: ['вск','пнд','втр','срд','чтв','птн','сбт'],
    dayNamesMin: ['Вс','Пн','Вт','Ср','Чт','Пт','Сб'],
  };
  var pfl = 'datepicker_'.length;
  $('.datepicker_input').each(function() {
    var nameSel = this.id.substring(pfl);
    initDatepicker(nameSel);
  });
  var sts = $('.selectEventStartTime');
  $('.customSelect').each(function() {
    var pfl = 'select_'.length;
    var nameSel = this.id.substring(pfl);
    initCustomSelect(nameSel);
  });
  var st = getParameterByName('EventStartTime');
  if(st) {
    var min_diff = 86400;
    var closest;
    var str;
    var diff;
    $('select[name="EventStartTime"] option').each(function() {
      diff = Math.abs(st - $(this).val());
      if(diff < min_diff) {
        min_diff = diff;
        closest = $(this).val();
        str = $(this).text();
      }
    });
    if(closest) {
      $('select[name="EventStartTime"]').val(closest);
      sts.children('span').text(str);
    }
  }
  var sd = getParameterByName('EventStartDate');
  if(sd) {
    sd = sd.replace(/^(\d{2})\-(\d{2})-(\d{4})$/, "$3$2$1");
    $('input[name="EventStartDate"]').val(sd);
  }
  $('.forwardedMessage style, .forwardedMessage script, .forwardedMessage .rfcheaderlinks').remove();
  $('.forwardedMessage a[href^="MIME/"]').each(function() {
    $(this).children('img, br, b').remove();
    var name = $(this).text();
    $(this).html('<span>' + name + '</span>');
    $(this).addClass('attach');
  });
});

function initDatepicker(nameSel) {
  var dtpckr = $('#datepicker_' + nameSel);
  var link = $('#link_' + nameSel);
  var select = $('select[name="' + nameSel + '"]');
  if(!select.length) select = $('input[name="' +  nameSel + '"]');
  var input = {
    D: $('input[name="' + nameSel + '-D"]'),
    M: $('input[name="' + nameSel + '-M"]'),
    Y: $('input[name="' + nameSel + '-y"]'),
  };
  dtpckr.datepicker(
    {
      firstDay: 1,
      dateFormat: 'dd-mm-yy',
    }
  );
  var locale = $('html').attr('lang');
  if(locale == 'ru') dtpckr.datepicker("option", $.datepicker.regional[locale]);
  dtpckr.on('change', function() {
    link.text($(this).val());
    var arr = $(this).val().split('-');
    var result = arr[2] + arr[1] + arr[0];
    if(select.length) select.val(result);
    else {
      input.D.val(arr[0]);
      input.M.val(arr[1]);
      input.Y.val(arr[2]);
    }
  });
  link.on('click', function(e) {
    e.preventDefault();
    dtpckr.trigger('focus');
  });
  $('.ui-widget:last-child').addClass('popupEsc');
  // <from calendar>
  var sd = getParameterByName(nameSel);
  if(sd) {
    dtpckr.datepicker('setDate', sd);
    dtpckr.trigger('change');
  } else {
  // </from calendar>
    if(select.length) sd = select.val();
    else sd = input.Y.val().toString() + input.M.val().toString() + input.D.val().toString();
    if(sd) {
      sd = sd.substring(6) + '-' + sd.substring(4,6) + '-' + sd.substring(0,4);
      link.text(sd);
      dtpckr.datepicker('setDate', sd);
    }
  }
}

function initCustomSelect(nameSel) {
  $('.ui-layout-center').scrollTop(0);
  var select = $('select[name="' + nameSel + '"]');
  var sts = $('#select_' + nameSel);
  var dd = $('.' + nameSel + 'DropDown');
  sts.children('span').text(select.find('option:selected').text());
  if(nameSel == 'EventStartTime' && $('input[name="isEvent"]').length) {
    $('input[name="allDayEvent"]').on('change', function() {
      if($(this).prop('checked')) {
        sts.css('visibility', 'hidden');
        //$('select[name="EventDuration"]').val("86400");
      } else {
        sts.css('visibility', 'visible');
        //$('select[name="EventDuration"]').val("1800");
      }
    });
  }
  if(nameSel == 'Priority') {
    var color;
    select.find('option').each(function() {
      if($(this).val() == 1) color = 'red';
      else if($(this).val() == 5) color = 'yellow';
      else if($(this).val() == 9) color = 'green';
      dd.append(
        '<li title="' + $(this).val() + '">' +
        '<div class="left priorityIndicator ' + color + '"></div><span>' + $(this).text() + '</span>' +
        '</li>'
      );
    });
    sts.html($('.PriorityDropDown li[title="' + select.find('option:selected').val() + '"]').html());
  } else {
    select.find('option').each(function() {
      dd.append('<li title="' + $(this).val() + '">' + $(this).text() + '</li>');
    });
  }
  sts.on('click', function(e) {
    e.preventDefault();
    dd.slideToggle();
  });
  var top_corr = -95;
  var width = sts.children('span').width() + 24;
  if(nameSel == 'Priority') {
    sts.css('background-position', sts.width() + 24);
    top_corr = -82;
    width = sts.width() + 50;
  }
  dd.css('min-width', width);
  dd.css('max-height', 41*6);
  dd.css(
    'left',
    sts.offset().left
  );
  dd.css(
    'top',
    sts.offset().top + sts.height() + top_corr
  );
  dd.children('li').on('click', function() {
    if(nameSel == 'Priority') sts.html($(this).html());
    else sts.children('span').text($(this).text());
    select.val($(this).attr('title'));
    $('.popupBlock').slideUp('fast');
  });
}

